SystemOrganization addCategory: #'EjerciciosPoo-TusLibros'!

Object subclass: #Cart
	instanceVariableNames: 'content catalogue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!Cart class methodsFor: 'as yet unclassified' stamp: 'TuVieja 5/29/2013 17:36'!
createWithcatalogue: aCatalogue
 	| cartToReturn |
	cartToReturn := self new.
	^cartToReturn initializeWithCatalogue: aCatalogue. ! !

!Cart methodsFor: 'as yet unclassified' stamp: 'TuVieja 5/29/2013 20:35'!
add: aBook
	( catalogue includes: aBook )ifTrue:[ content add: aBook ].
	self error:'$NOT IN CATALOGUE$'.
	! !

!Cart methodsFor: 'as yet unclassified' stamp: 'TuVieja 5/29/2013 20:31'!
hasItem: aBook
	^ content includes: aBook.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'TuVieja 5/29/2013 20:31'!
initialize 
	catalogue := Set  new.
	content:= Bag new.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'TuVieja 5/29/2013 20:13'!
initializeWithCatalogue: aCatalogue
	catalogue := aCatalogue.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'TuVieja 5/29/2013 17:43'!
isEmpty
	^content size = 0.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'TuVieja 5/29/2013 20:16'!
itemIsInCatalog:anItem
^ catalogue includes: anItem! !

!Cart methodsFor: 'as yet unclassified' stamp: 'TuVieja 5/29/2013 19:23'!
numberofCartElements
	^ content size.! !

Object subclass: #Catalogue
	instanceVariableNames: 'content'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!Catalogue methodsFor: 'as yet unclassified' stamp: 'TuVieja 5/29/2013 20:13'!
add: aBook 

	"(aBook not numeric)ifTue:[RAISE NN ERROR]"
	(aBook asByteString  byteSize = 13)ifFalse: [ self error:'$WRONG ISBN SIZE$' ].
	content add: aBook.! !

!Catalogue methodsFor: 'as yet unclassified' stamp: 'TuVieja 5/29/2013 17:48'!
containsBook: aBook 
	^ content containsBook: aBook! !

!Catalogue methodsFor: 'as yet unclassified' stamp: 'TuVieja 5/29/2013 17:41'!
initialize
	content:= Set new.! !

TestCase subclass: #TusLibrosTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/27/2013 21:03'!
test01newCartMustBeEmptyOnCreation

	self assert: self cart isEmpty.! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'TuVieja 5/29/2013 20:13'!
test02CannotAddNotNumericISBNToCatalogue
	
	| aCart aBook |
	aCart := Cart new.
	aBook := '123456p678901'.
	self should: [ aCart catalog add: aBook. self assert: (aCart hasItem: aBook) .] raise: Error withExceptionDo: [ :anError | self assert: anError  ].! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'TuVieja 5/29/2013 20:13'!
test03CannotAddISBNWithLessOf13DigitsToCatalogue
	| aCart aBook |
	aCart := Cart new.
	aBook := '123456678901'.
	self should: [ aCart catalog add: aBook. self assert: (aCart hasItem: aBook) .] raise: Error withExceptionDo: [ :anError | self assert: anError messageText = '$WRONG ISBN SIZE$'  ].	
	! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'TuVieja 5/29/2013 20:34'!
test03cartMustNotBeEmptyAfterAddingABook
	
	|aCart aCatalog|
	
	aCart := Cart new.
	aCatalog:= Set new.
	aCatalog add: '8709427699867'.
	aCart initializeWithCatalogue: aCatalog.
	aCart add: '8709427699867'.
	self deny: aCart isEmpty.! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'TuVieja 5/29/2013 20:13'!
test04cannotAddBookIfItIsNotPresentInCatalogue
	
	|aCart aBook aCatalogue|
	
	aCart := self cart.
	aBook := '3809547805003'.
	
	
	self should: [ aCart add: aBook. self assert: (aCart hasItem: aBook) .] raise: Error withExceptionDo: [ :anError | self assert: anError  ].

	! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'TuVieja 5/29/2013 20:13'!
test05OnlyAddedBookMustBeInCartAfterAddition
	
	|aCart aBook |
	
	aCart := self cart.
	aBook := '4444445678888'.
	aCart catalog add: aBook.
	aCart add: aBook.

	self assert: (aCart hasItem: aBook).
	self assert:( aCart numberofCartElements = 1 ).! !
